#include <intuition/intuitionbase.h>
#include <libraries/dosextens.h>
#include <graphics/displayinfo.h>
#include <libraries/gadtools.h>

#include <ntp.h>

extern struct IntuitionBase *IntuitionBase;
extern char drives[NUMD+1][7];
extern struct WinPrefs wp[2];
extern struct Screen *OpenScreen(),*OpenScreenTags();
extern struct Window *OpenWindow();

struct TextAttr TOPAZ60 = {
   (STRPTR)"topaz.font",
   TOPAZ_EIGHTY,0,0
};
struct NewScreen NewScreenStructure = {
   0,0,
   640,256,
   3,
   YELLOW,DARK,
   HIRES,
   CUSTOMSCREEN,
   &TOPAZ60,
   "NTP 2.2 by Patrik Sucansky",
   NULL,
   NULL
};

#define NEWSCREENSTRUCTURE NewScreenStructure
/*
USHORT Palette[] = {
   0x0303,
   0x0DA8,
   0x0A75,
   0x0753
#define PaletteColorCount 4
};

#define PALETTE Palette
*/

SHORT NWBorderVectors2[] = {
   105,0,
   105,11,
   0,11,
   0,3,
   6,3,
   6,0,
   105,0
};

struct Border NWBorder2xx = {
   -1,-1,
   DGRAY,0,JAM1,
   3,
   NWBorderVectors2,
   NULL
};

struct Border NWBorder3 = {
   -1,-1,
   WHITE,0,JAM1,
   5,
   NWBorderVectors2+4,
   &NWBorder2xx
};

struct Border NWBorder3xx = {
   -1,-1,
   WHITE,0,JAM1,
   3,
   NWBorderVectors2,
   NULL
};

struct Border NWBorder4 = {
   -1,-1,
   DGRAY,0,JAM1,
   5,
   NWBorderVectors2+4,
   &NWBorder3xx
};



struct IntuiText NWIText1 = {
   DARK,GRAY,JAM2,
   10,1,
   NULL,
#ifdef GERMAN
   "Kopieren F5",
#else
   "Copy     F5",
#endif
   NULL
};

struct Gadget NWGadget18 = {
   NULL,
   533,-52,
   99,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText1,
   NULL,
   NULL,
   5,
   NULL
};

struct IntuiText NWIText2 = {
   DARK,GRAY,JAM2,
   10,1,
   NULL,
#ifdef GERMAN
   "Editier. F4",
#else
   "Edit     F4",
#endif
   NULL
};

struct Gadget NWGadget17 = {
   &NWGadget18,
   427,-52,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText2,
   NULL,
   NULL,
   4,
   NULL
};

struct IntuiText NWIText3 = {
   DARK,GRAY,JAM2,
   10,1,
   NULL,
#ifdef GERMAN
   "HexLese",
#else
   "HexRead",
#endif
   NULL
};

struct Gadget NWGadget16 = {
   &NWGadget17,
   321,-52,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText3,
   NULL,
   NULL,
   3,
   NULL
};

struct IntuiText NWIText4 = {
   DARK,GRAY,JAM2,
   10,1,
   NULL,
   "Menu     F2",
   NULL
};

struct Gadget NWGadget15 = {
   &NWGadget16,
   215,-52,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText4,
   NULL,
   NULL,
   2,
   NULL
};

struct IntuiText NWIText5 = {
   DARK,GRAY,JAM2,
   10,1,
   NULL,
#ifdef GERMAN
   "Prozess",
#else
   "Process",
#endif
   NULL
};

struct Gadget NWGadget14 = {
   &NWGadget15,
   109,-52,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText5,
   NULL,
   NULL,
   11,
   NULL
};

struct IntuiText NWIText6 = {
   YELLOW,GRAY,JAM2,
   37,1,
   NULL,
   "DF0:",
   NULL
};

struct Gadget NWGadget13 = {
   &NWGadget14,
   3,-52,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText6,
   NULL,
   NULL,
   17,
   0
};

struct IntuiText NWIText7 = {
   DARK,GRAY,JAM2,
   10,1,
   NULL,
#ifdef GERMAN
   "Schutz    ",
#else
   "Protection",
#endif
   NULL
};

struct Gadget NWGadget12 = {
   &NWGadget13,
   533,-40,
   99,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText7,
   NULL,
   NULL,
   12,
   NULL
};

struct IntuiText NWIText8 = {
   DARK,GRAY,JAM2,
   10,1,
   NULL,
#ifdef GERMAN
   "Neu Name F9",
#else
   "Rename   F9",
#endif
   NULL
};

struct Gadget NWGadget11 = {
   &NWGadget12,
   427,-40,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText8,
   NULL,
   NULL,
   9,
   NULL
};

struct IntuiText NWIText9 = {
   WHITE,GRAY,JAM2,
   10,1,
   NULL,
#ifdef GERMAN
   "Lschen  F8",
#else
   "Delete   F8",
#endif
   NULL
};

struct Gadget NWGadget10 = {
   &NWGadget11,
   321,-40,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText9,
   NULL,
   NULL,
   8,
   NULL
};

struct IntuiText NWIText10 = {
   DARK,GRAY,JAM2,
   10,1,
   NULL,
#ifdef GERMAN
   "Neue Ver.F7",
#else
   "Make dir F7",
#endif
   NULL
};

struct Gadget NWGadget9 = {
   &NWGadget10,
   215,-40,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText10,
   NULL,
   NULL,
   7,
   NULL
};

struct IntuiText NWIText11 = {
   DARK,GRAY,JAM2,
   10,1,
   NULL,
#ifdef GERMAN
   "Schieben F6",
#else
   "Move     F6",
#endif
   NULL
};

struct Gadget NWGadget8 = {
   &NWGadget9,
   109,-40,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText11,
   NULL,
   NULL,
   6,
   NULL
};

struct IntuiText NWIText12 = {
   YELLOW,GRAY,JAM2,
   37,1,
   NULL,
   "RAM:",
   NULL
};

struct Gadget NWGadget7 = {
   &NWGadget8,
   3,-40,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText12,
   NULL,
   NULL,
   18,
   4
};

struct IntuiText NWIText13 = {
   WHITE,GRAY,JAM2,
   10,1,
   NULL,
#ifdef GERMAN
   "Ausgang F10",
#else
   "Exit    F10",
#endif
   NULL
};

struct Gadget NWGadget6 = {
   &NWGadget7,
   533,-28,
   99,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText13,
   NULL,
   NULL,
   10,
   NULL
};

struct IntuiText NWIText14 = {
   DARK,GRAY,JAM2,
   10,1,
   NULL,
#ifdef GERMAN
   "Druck",
#else
   "Print",
#endif
   NULL
};

struct Gadget NWGadget5 = {
   &NWGadget6,
   427,-28,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText14,
   NULL,
   NULL,
   16,
   NULL
};

struct IntuiText NWIText15 = {
   DARK,GRAY,JAM2,
   10,1,
   NULL,
   "IFF-Picture",
   NULL
};

struct Gadget NWGadget4 = {
   &NWGadget5,
   321,-28,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText15,
   NULL,
   NULL,
   13,
   NULL
};

struct IntuiText NWIText16 = {
   DARK,GRAY,JAM2,
   10,1,
   NULL,
#ifdef GERMAN
   "Spiele Inst",
#else
   "Play sound",
#endif
   NULL
};

struct Gadget NWGadget3 = {
   &NWGadget4,
   215,-28,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText16,
   NULL,
   NULL,
   14,
   NULL
};

struct IntuiText NWIText17 = {
   YELLOW,GRAY,JAM2,
   10,1,
   NULL,
#ifdef GERMAN
   "Mutterverz.",
#else
   "Parent",
#endif
   NULL
};

struct Gadget NWGadget2 = {
   &NWGadget3,
   109,-28,
   104,10,
   GADGHIMAGE+GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText17,
   NULL,
   NULL,
   15,
   NULL
};

struct IntuiText NWIText18 = {
   YELLOW,GRAY,JAM2,
   38,1,
   NULL,
   "RAD:",
   NULL
};

struct Gadget NWGadget1 = {
   &NWGadget2,
   3,-28,
   104,10,
   GADGHIMAGE|GRELBOTTOM,
   RELVERIFY,
   BOOLGADGET,
   (APTR)&NWBorder3,
   (APTR)&NWBorder4,
   &NWIText18,
   NULL,
   NULL,
   19,
   5
};

#define NWGadgetList1 NWGadget1

struct IntuiText NWIText19 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Porte",
#else
   "Ports",
#endif
   NULL
};

struct MenuItem NWSubItem5 = {
   NULL,
   73,24,
   99,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText19,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText20 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Speicher",
#else
   "Memory",
#endif
   NULL
};

struct MenuItem NWSubItem4 = {
   &NWSubItem5,
   73,16,
   99,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText20,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText21 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Tasks",
   NULL
};

struct MenuItem NWSubItem3 = {
   &NWSubItem4,
   73,8,
   99,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText21,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText22 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "ResModule",
   NULL
};

struct MenuItem NWSubItem2 = {
   &NWSubItem3,
   73,0,
   99,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText22,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText23 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Resident",
   NULL
};

struct MenuItem NWSubItem1 = {
   &NWSubItem2,
   73,-8,
   99,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText23,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText24 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
   "Exec List",
   NULL
};

struct MenuItem NWMenuItem6 = {
   NULL,
   0,40,
#ifdef GERMAN
   112,8,
#else
   88,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHBOX,
   0,
   (APTR)&NWIText24,
   NULL,
   NULL,
   &NWSubItem1,
   MENUNULL
};

struct IntuiText NWIText25 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "ICase",
   NULL
};

struct MenuItem NWMenuItem5 = {
   &NWMenuItem6,
   0,32,
#ifdef GERMAN
   112,8,
#else
   88,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText25,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText26 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Weg Alt+F2",
#else
   "Path Alt+F2",
#endif
   NULL
};

struct MenuItem NWMenuItem4 = {
   &NWMenuItem5,
   0,24,
#ifdef GERMAN
   112,8,
#else
   88,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText26,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText27 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
   "Filter",
   NULL
};

struct MenuItem NWMenuItem3 = {
   &NWMenuItem4,
   0,16,
#ifdef GERMAN
   112,8,
#else
   88,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText27,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText28 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Separaten Verz.",
#else
   "Separate Dirs",
#endif
   NULL
};

struct MenuItem NWSubItem9 = {
   NULL,
   73,16,
#ifdef GERMAN
   139,8,
#else
   123,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText28,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText29 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Lnge",
#else
   "Size Sort",
#endif
   NULL
};

struct MenuItem NWSubItem8 = {
   &NWSubItem9,
   73,8,
#ifdef GERMAN
   139,8,
#else
   123,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText29,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText30 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Name",
#else
   "Name Sort",
#endif
   NULL
};

struct MenuItem NWSubItem7 = {
   &NWSubItem8,
   73,0,
#ifdef GERMAN
   139,8,
#else
   123,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText30,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText31 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Nicht sortieren",
#else
   "UnSorted",
#endif
   NULL
};

struct MenuItem NWSubItem6 = {
   &NWSubItem7,
   73,-8,
#ifdef GERMAN
   139,8,
#else
   123,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText31,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText32 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Sortieren nach",
#else
   "Sort",
#endif
   NULL
};

struct MenuItem NWMenuItem2 = {
   &NWMenuItem3,
   0,8,
#ifdef GERMAN
   112,8,
#else
   88,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHBOX,
   0,
   (APTR)&NWIText32,
   NULL,
   NULL,
   &NWSubItem6,
   MENUNULL
};

struct IntuiText NWIText33 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Exec List",
   NULL
};

struct MenuItem NWSubItem16 = {
   NULL,
   73,40,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText33,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText34 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Gerte",
#else
   "Devices",
#endif
   NULL
};

struct MenuItem NWSubItem15 = {
   &NWSubItem16,
   73,32,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText34,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText35 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Assigns",
   NULL
};

struct MenuItem NWSubItem14 = {
   &NWSubItem15,
   73,24,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText35,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText36 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Info",
#else
   "Avail Info",
#endif
   NULL
};

struct MenuItem NWSubItem13 = {
   &NWSubItem14,
   73,16,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText36,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText37 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Schnelle lesen",
#else
   "Quick View",
#endif
   NULL
};

struct MenuItem NWSubItem12 = {
   &NWSubItem13,
   73,8,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText37,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText38 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Baum",
#else
   "Tree",
#endif
   NULL
};

struct MenuItem NWSubItem11 = {
   &NWSubItem12,
   73,0,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText38,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText39 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Dateien",
#else
   "Files",
#endif
   NULL
};

struct MenuItem NWSubItem10 = {
   &NWSubItem11,
   73,-8,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText39,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText40 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
   "Type",
   NULL
};

struct MenuItem NWMenuItem1 = {
   &NWMenuItem2,
   0,0,
#ifdef GERMAN
   112,8,
#else
   88,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHBOX,
   0,
   (APTR)&NWIText40,
   NULL,
   NULL,
   &NWSubItem10,
   MENUNULL
};

struct Menu NWMenu5 = {
   NULL,
#ifdef GERMAN
   302,0,
#else
   272,0,
#endif
#ifdef GERMAN
   53,0,
#else
   47,0,
#endif
   MENUENABLED,
#ifdef GERMAN
   "Rechts",
#else
   "Right",
#endif
   &NWMenuItem1
};


struct IntuiText NWIText41bbbb = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Wie WB-screen",
#else
   "Like WB-screen",
#endif
   NULL
};

struct MenuItem NWMenuItem9bbbb = {
   NULL,
   0,96,
#ifdef GERMAN
   159,8,
#else
   127,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText41bbbb,
   NULL,
   0,
   NULL,
   MENUNULL
};



struct IntuiText NWIText41bb = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "# des Kannelen",
#else
   "# of channels",
#endif
   NULL
};

struct MenuItem NWMenuItem9bb = {
   &NWMenuItem9bbbb,
   0,88,
#ifdef GERMAN
   159,8,
#else
   127,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText41bb,
   NULL,
   0,
   NULL,
   MENUNULL
};


struct IntuiText NWIText41c = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Strikt NC",
#else
   "Strict NC",
#endif
   NULL
};

struct MenuItem NWMenuItem9c = {
   &NWMenuItem9bb,
   0,80,
#ifdef GERMAN
   159,8,
#else
   127,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText41c,
   NULL,
   0,
   NULL,
   MENUNULL
};


struct IntuiText NWIText41bbb = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Farbe",
#else
   "Color",
#endif
   NULL
};

struct MenuItem NWMenuItem9bbb = {
   &NWMenuItem9c,
   0,72,
#ifdef GERMAN
   159,8,
#else
   127,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText41bbb,
   NULL,
   0,
   NULL,
   MENUNULL
};


struct IntuiText NWIText41b = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Maus weg",
#else
   "Mouse blank",
#endif
   NULL
};

struct MenuItem NWMenuItem9b = {
   &NWMenuItem9bbb,
   0,64,
#ifdef GERMAN
   159,8,
#else
   127,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText41b,
   NULL,
   0,
   NULL,
   MENUNULL
};


struct IntuiText NWIText41aa = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "berschreibe Req.",
#else
   "Overwrite req.",
#endif
   NULL
};

struct MenuItem NWMenuItem9aa = {
   &NWMenuItem9b,
   0,56,
#ifdef GERMAN
   159,8,
#else
   127,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText41aa,
   NULL,
   0,
   NULL,
   MENUNULL
};

struct IntuiText NWIText41a = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "SysRequestern",
#else
   "SysRequests",
#endif
   NULL
};

struct MenuItem NWMenuItem9a = {
   &NWMenuItem9aa,
   0,48,
#ifdef GERMAN
   159,8,
#else
   127,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText41a,
   NULL,
   0,
   NULL,
   MENUNULL
};


struct IntuiText NWIText41xxx = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
#ifdef GERMAN
   "Gadgeten",
#else
   "Gadgets",
#endif
   NULL
};

struct MenuItem NWMenuItem9xxx = {
   &NWMenuItem9a,
   0,40,
#ifdef GERMAN
   159,8,
#else
   127,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText41xxx,
   NULL,
   0,
   NULL,
   MENUNULL
};

struct IntuiText NWIText41xx = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Schutz/Datum/Zeit",
#else
   "Prot./Date/Time",
#endif
   NULL
};

struct MenuItem NWMenuItem9xx = {
   &NWMenuItem9xxx,
   0,32,
#ifdef GERMAN
   159,8,
#else
   127,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText41xx,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText41x = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Tab Lnge",
#else
   "Tab Size",
#endif
   NULL
};

struct MenuItem NWMenuItem9x = {
   &NWMenuItem9xx,
   0,24,
#ifdef GERMAN
   159,8,
#else
   127,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText41x,
   NULL,
   0,
   NULL,
   MENUNULL
};



struct IntuiText NWIText41 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Sichern",
#else
   "Save",
#endif
   NULL
};

struct MenuItem NWMenuItem9 = {
   &NWMenuItem9x,
   0,16,
#ifdef GERMAN
   159,8,
#else
   127,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText41,
   NULL,
   'w',
   NULL,
   MENUNULL
};

struct IntuiText NWIText42 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Standard",
#else
   "Default",
#endif
   NULL
};

struct MenuItem NWMenuItem8 = {
   &NWMenuItem9,
   0,8,
#ifdef GERMAN
   159,8,
#else
   127,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText42,
   NULL,
   't',
   NULL,
   MENUNULL
};

struct IntuiText NWIText43 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Laden",
#else
   "Load",
#endif
   NULL
};

struct MenuItem NWMenuItem7 = {
   &NWMenuItem8,
   0,0,
#ifdef GERMAN
   159,8,
#else
   127,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText43,
   NULL,
   'l',
   NULL,
   MENUNULL
};

struct Menu NWMenu4 = {
   &NWMenu5,
#ifdef GERMAN
   186,0,
#else
   170,0,
#endif
#ifdef GERMAN
   114,0,
#else
   98,0,
#endif
   MENUENABLED,
#ifdef GERMAN
   "Einstellungen",
#else
   "Preferences",
#endif
   &NWMenuItem7
};

struct IntuiText NWIText44a = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Ausgang       F10",
#else
   "Exit          F10",
#endif
   NULL
};

struct MenuItem NWMenuItem24a = {
   NULL,
   0,128,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText44a,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

/*---------------------------------------------------*
  Gadgets created with PowerSource V3.0
  which is (c) Copyright 1990-91 by Jaba Development
  written by Jan van den Baard
 *---------------------------------------------------*/

struct IntuiText SubItemsText[] = {
  WHITE,1,JAM1,1,1,NULL,(UBYTE *)"NTP by Patrick Sucansky ",NULL,
  WHITE,1,JAM1,1,1,NULL,(UBYTE *)" Slovakia -427/828439   ",NULL,
  WHITE,1,JAM1,1,1,NULL,(UBYTE *)"IFF support from program",NULL,
  WHITE,1,JAM1,1,1,NULL,(UBYTE *)"QIFF by                 ",NULL,
  WHITE,1,JAM1,1,1,NULL,(UBYTE *)"  John 'Quicho' Kupecky ",NULL,
  WHITE,1,JAM1,1,1,NULL,(UBYTE *)"Debugging & Tech. supp. ",NULL,
  WHITE,1,JAM1,1,1,NULL,(UBYTE *)"  by Henry Raduska.     ",NULL};

struct MenuItem SubItems[] = {
  &SubItems[1],40,0,136,9,ITEMENABLED+HIGHNONE+ITEMTEXT,0,(APTR)&SubItemsText[0],NULL,0,NULL,0,
  &SubItems[2],40,9,136,9,ITEMENABLED+HIGHNONE+ITEMTEXT,0,(APTR)&SubItemsText[1],NULL,0,NULL,0,
  &SubItems[3],40,18,136,9,ITEMENABLED+HIGHNONE+ITEMTEXT,0,(APTR)&SubItemsText[2],NULL,0,NULL,0,
  &SubItems[4],40,27,136,9,ITEMENABLED+HIGHNONE+ITEMTEXT,0,(APTR)&SubItemsText[3],NULL,0,NULL,0,
  &SubItems[5],40,36,136,9,ITEMENABLED+HIGHNONE+ITEMTEXT,0,(APTR)&SubItemsText[4],NULL,0,NULL,0,
  &SubItems[6],40,45,136,9,ITEMENABLED+HIGHNONE+ITEMTEXT,0,(APTR)&SubItemsText[5],NULL,0,NULL,0,
  NULL,40,54,136,9,ITEMENABLED+HIGHNONE+ITEMTEXT,0,(APTR)&SubItemsText[6],NULL,0,NULL,0 };

struct IntuiText NWIText44 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Info",
#else
   "About",
#endif
   NULL
};

struct MenuItem NWMenuItem24 = {
   &NWMenuItem24a,
   0,120,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText44,
   NULL,
   NULL,
   &SubItems[0],
   MENUNULL
};


struct IntuiText NWIText45x = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "DOS Fehler",
#else
   "Dos Error",
#endif
   NULL
};

struct MenuItem NWMenuItem24x = {
   &NWMenuItem24,
   0,112,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText45x,
   NULL,
   'e',
   NULL,
   MENUNULL
};



struct IntuiText NWIText45 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Sehe Block",
#else
   "View Block",
#endif
   NULL
};

struct MenuItem NWMenuItem23 = {
   &NWMenuItem24x,
   0,104,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText45,
   NULL,
   'b',
   NULL,
   MENUNULL
};

struct IntuiText NWIText46 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Editiere Neue",
#else
   "Edit New",
#endif
   NULL
};

struct MenuItem NWMenuItem22 = {
   &NWMenuItem23,
   0,96,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText46,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText47 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Finde      Alt+F7",
#else
   "Find       Alt+F7",
#endif
   NULL
};

struct MenuItem NWMenuItem21 = {
   &NWMenuItem22,
   0,88,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText47,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText48 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Assign Verz.",
#else
   "Assign Dir",
#endif
   NULL
};

struct MenuItem NWMenuItem20 = {
   &NWMenuItem21,
   0,80,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText48,
   NULL,
   'a',
   NULL,
   MENUNULL
};

struct IntuiText NWIText49 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Disk Kopier.",
#else
   "Disk Copy",
#endif
   NULL
};

struct MenuItem NWMenuItem19 = {
   &NWMenuItem20,
   0,72,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText49,
   NULL,
   'd',
   NULL,
   MENUNULL
};

struct IntuiText NWIText50 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Format",
#else
   "Format Disk",
#endif
   NULL
};

struct MenuItem NWMenuItem18 = {
   &NWMenuItem19,
   0,64,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText50,
   NULL,
   'f',
   NULL,
   MENUNULL
};

struct IntuiText NWIText51 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "S-Format",
#else
   "Quick format",
#endif
   NULL
};

struct MenuItem NWMenuItem17 = {
   &NWMenuItem18,
   0,56,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText51,
   NULL,
   'q',
   NULL,
   MENUNULL
};

struct IntuiText NWIText52 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Instalieren",
#else
   "Install",
#endif
   NULL
};

struct MenuItem NWMenuItem16 = {
   &NWMenuItem17,
   0,48,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText52,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText53 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Kalkulator",
#else
   "Calculator",
#endif
   NULL
};

struct MenuItem NWMenuItem15 = {
   &NWMenuItem16,
   0,40,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText53,
   NULL,
   'c',
   NULL,
   MENUNULL
};

struct IntuiText NWIText54 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Lese NTP.Cfg",
#else
   "Read NTP.Cfg",
#endif
   NULL
};

struct MenuItem NWMenuItem14 = {
   &NWMenuItem15,
   0,32,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText54,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText55 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Einschlafen",
#else
   "Iconify",
#endif
   NULL
};

struct MenuItem NWMenuItem13 = {
   &NWMenuItem14,
   0,24,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText55,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText56 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Neue Verz.     F7",
#else
   "Make dir       F7",
#endif
   NULL
};

struct MenuItem NWMenuItem12 = {
   &NWMenuItem13,
   0,16,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText56,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText57 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
   "Menu           F2",
   NULL
};

struct MenuItem NWMenuItem11 = {
   &NWMenuItem12,
   0,8,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText57,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText58 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Hilfe          F1",
#else
   "Help           F1",
#endif
   NULL
};

struct MenuItem NWMenuItem10 = {
   &NWMenuItem11,
   0,0,
   136,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText58,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct Menu NWMenu3 = {
   &NWMenu4,
#ifdef GERMAN
   116,0,
#else
   100,0,
#endif
   63,0,
   MENUENABLED,
#ifdef GERMAN
   "Spezial",
#else
   "Special",
#endif
   &NWMenuItem10
};

struct IntuiText NWIText59 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Aus-Muster     -",
#else
   "UnSelect Group -",
#endif
   NULL
};

struct MenuItem NWMenuItem42 = {
   NULL,
   0,144,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText59,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText60 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Ein Muster     +",
#else
   "Select Group   +",
#endif
   NULL
};

struct MenuItem NWMenuItem41 = {
   &NWMenuItem42,
   0,136,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText60,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText61aa = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Lnge Info",
#else
   "Size Info",
#endif
   NULL
};

struct MenuItem NWMenuItem40aa = {
   &NWMenuItem41,
   0,128,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText61aa,
   NULL,
   '-',
   NULL,
   MENUNULL
};



struct IntuiText NWIText61xx = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Schutz",
#else
   "Protection",
#endif
   NULL
};

struct MenuItem NWMenuItem40xx = {
   &NWMenuItem40aa,
   0,120,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText61xx,
   NULL,
   'r',
   NULL,
   MENUNULL
};


struct IntuiText NWIText61x = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Kodieren",
#else
   "Encrypt",
#endif
   NULL
};

struct MenuItem NWMenuItem40x = {
   &NWMenuItem40xx,
   0,112,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText61x,
   NULL,
   NULL,
   NULL,
   MENUNULL
};


struct IntuiText NWIText63 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Suchen      Alt+F6",
#else
   "Search      Alt+F6",
#endif
   NULL
};

struct MenuItem NWMenuItem38 = {
   &NWMenuItem40x,
   0,104,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText63,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText64x = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Spiele NTmod.",
#else
   "Play NTmodule   ",
#endif
   NULL
};

struct MenuItem NWMenuItem37x = {
   &NWMenuItem38,
   0,96,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText64x,
   NULL,
   'n',
   NULL,
   MENUNULL
};

struct IntuiText NWIText66 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Spiele Inst.",
#else
   "Play Sound",
#endif
   NULL
};

struct MenuItem NWMenuItem35 = {
   &NWMenuItem37x,
   0,88,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText66,
   NULL,
   's',
   NULL,
   MENUNULL
};

struct IntuiText NWIText67 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
   "IFF Picture",
   NULL
};

struct MenuItem NWMenuItem34 = {
   &NWMenuItem35,
   0,80,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText67,
   NULL,
   'i',
   NULL,
   MENUNULL
};

struct IntuiText NWIText68 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Drucke Datei.",
#else
   "Print files",
#endif
   NULL
};

struct MenuItem NWMenuItem33 = {
   &NWMenuItem34,
   0,72,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,
   0,
   (APTR)&NWIText68,
   NULL,
   'p',
   NULL,
   MENUNULL
};

struct IntuiText NWIText69 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Neue Name       F9",
#else
   "Rename          F9",
#endif
   NULL
};

struct MenuItem NWMenuItem32 = {
   &NWMenuItem33,
   0,64,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText69,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText70 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Lschen         F8",
#else
   "Delete          F8",
#endif
   NULL
};

struct MenuItem NWMenuItem31 = {
   &NWMenuItem32,
   0,56,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText70,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText71 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Schieben        F6",
#else
   "Move            F6",
#endif
   NULL
};

struct MenuItem NWMenuItem30 = {
   &NWMenuItem31,
   0,48,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText71,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText72 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Kopieren        F5",
#else
   "Copy            F5",
#endif
   NULL
};

struct MenuItem NWMenuItem29 = {
   &NWMenuItem30,
   0,40,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText72,
   NULL,
   NULL,
   NULL,
   MENUNULL
};


struct IntuiText NWIText73x = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Hex-Edit.   Alt+F4",
#else
   "Hex-Edit    Alt+F4",
#endif
   NULL
};

struct MenuItem NWMenuItem28x = {
   &NWMenuItem29,
   0,32,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText73x,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText73 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Editieren       F4",
#else
   "Edit            F4",
#endif
   NULL
};

struct MenuItem NWMenuItem28 = {
   &NWMenuItem28x,
   0,24,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText73,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText74 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Hex-Lese    Alt+F3",
#else
   "Hex-View    Alt+F3",
#endif
   NULL
};

struct MenuItem NWMenuItem27 = {
   &NWMenuItem28,
   0,16,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText74,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText75 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Sehen           F3",
#else
   "View            F3",
#endif
   NULL
};

struct MenuItem NWMenuItem26 = {
   &NWMenuItem27,
   0,8,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText75,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText76 = {
   WHITE,KMZ,JAM1,
   0,0,
   NULL,
#ifdef GERMAN
   "Ausfhren",
#else
   "Execute",
#endif
   NULL
};

struct MenuItem NWMenuItem25 = {
   &NWMenuItem26,
   0,0,
   144,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
   (APTR)&NWIText76,
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct Menu NWMenu2 = {
   &NWMenu3,
   46,0,
#ifdef GERMAN
   63,0,
#else
   47,0,
#endif
   MENUENABLED,
#ifdef GERMAN
   "Dateien",
#else
   "Files",
#endif
   &NWMenuItem25
};

struct IntuiText NWIText77 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Ports",
   NULL
};

struct MenuItem NWSubItem21 = {
   NULL,
   73,24,
   99,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText19,
#else
   (APTR)&NWIText77,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText78 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Memory",
   NULL
};

struct MenuItem NWSubItem20 = {
   &NWSubItem21,
   73,16,
   99,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText20,
#else
   (APTR)&NWIText78,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText79 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Tasks",
   NULL
};

struct MenuItem NWSubItem19 = {
   &NWSubItem20,
   73,8,
   99,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText21,
#else
   (APTR)&NWIText79,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText80 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "ResModule",
   NULL
};

struct MenuItem NWSubItem18 = {
   &NWSubItem19,
   73,0,
   99,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText22,
#else
   (APTR)&NWIText80,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText81 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Resident",
   NULL
};

struct MenuItem NWSubItem17 = {
   &NWSubItem18,
   73,-8,
   99,8,
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText23,
#else
   (APTR)&NWIText81,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct TextAttr TOPAZ80 = {
   (STRPTR)"topaz.font",
   TOPAZ_EIGHTY,0,0
};
struct IntuiText NWIText82 = {
   WHITE,KMZ,JAM1,
   0,0,
   &TOPAZ80,
   "Exec list",
   NULL
};

struct MenuItem NWMenuItem48 = {
   NULL,
   0,40,
#ifdef GERMAN
   112,8,
#else
   88,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHBOX,
   0,
#ifdef GERMAN
   (APTR)&NWIText24,
#else
   (APTR)&NWIText82,
#endif
   NULL,
   NULL,
   &NWSubItem17,
   MENUNULL
};

struct IntuiText NWIText83 = {
   WHITE,KMZ,JAM1,
   19,0,
   &TOPAZ80,
   "ICase",
   NULL
};

struct MenuItem NWMenuItem47 = {
   &NWMenuItem48,
   0,32,
#ifdef GERMAN
   112,8,
#else
   88,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText25,
#else
   (APTR)&NWIText83,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText84 = {
   WHITE,KMZ,JAM1,
   0,0,
   &TOPAZ80,
   "Path Alt+F1",
   NULL
};

struct MenuItem NWMenuItem46 = {
   &NWMenuItem47,
   0,24,
#ifdef GERMAN
   112,8,
#else
   88,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText26,
#else
   (APTR)&NWIText84,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText85 = {
   WHITE,KMZ,JAM1,
   0,0,
   &TOPAZ80,
   "Filter",
   NULL
};

struct MenuItem NWMenuItem45 = {
   &NWMenuItem46,
   0,16,
#ifdef GERMAN
   112,8,
#else
   88,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText27,
#else
   (APTR)&NWIText85,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText86 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Separate Dirs",
   NULL
};

struct MenuItem NWSubItem25 = {
   NULL,
   73,16,
#ifdef GERMAN
   139,8,
#else
   123,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText28,
#else
   (APTR)&NWIText86,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText87 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Size Sort",
   NULL
};

struct MenuItem NWSubItem24 = {
   &NWSubItem25,
   73,8,
#ifdef GERMAN
   139,8,
#else
   123,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText29,
#else
   (APTR)&NWIText87,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText88 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Name Sort",
   NULL
};

struct MenuItem NWSubItem23 = {
   &NWSubItem24,
   73,0,
#ifdef GERMAN
   139,8,
#else
   123,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText30,
#else
   (APTR)&NWIText88,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText89 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "UnSorted",
   NULL
};

struct MenuItem NWSubItem22 = {
   &NWSubItem23,
   73,-8,
#ifdef GERMAN
   139,8,
#else
   123,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText31,
#else
   (APTR)&NWIText89,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText90 = {
   WHITE,KMZ,JAM1,
   0,0,
   &TOPAZ80,
   "Sort       ",
   NULL
};

struct MenuItem NWMenuItem44 = {
   &NWMenuItem45,
   0,8,
#ifdef GERMAN
   112,8,
#else
   88,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHBOX,
   0,
#ifdef GERMAN
   (APTR)&NWIText32,
#else
   (APTR)&NWIText90,
#endif
   NULL,
   NULL,
   &NWSubItem22,
   MENUNULL
};

struct IntuiText NWIText91 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Exec List",
   NULL
};

struct MenuItem NWSubItem32 = {
   NULL,
   73,40,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText33,
#else
   (APTR)&NWIText91,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText92 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Devices",
   NULL
};

struct MenuItem NWSubItem31 = {
   &NWSubItem32,
   73,32,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText34,
#else
   (APTR)&NWIText92,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText93 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Assigns",
   NULL
};

struct MenuItem NWSubItem30 = {
   &NWSubItem31,
   73,24,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText35,
#else
   (APTR)&NWIText93,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText94 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Avail info",
   NULL
};

struct MenuItem NWSubItem29 = {
   &NWSubItem30,
   73,16,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText36,
#else
   (APTR)&NWIText94,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText95 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Quick View",
   NULL
};

struct MenuItem NWSubItem28 = {
   &NWSubItem29,
   73,8,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText37,
#else
   (APTR)&NWIText95,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText96 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Tree",
   NULL
};

struct MenuItem NWSubItem27 = {
   &NWSubItem28,
   73,0,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText38,
#else
   (APTR)&NWIText96,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText97 = {
   WHITE,KMZ,JAM1,
   19,0,
   NULL,
   "Files",
   NULL
};

struct MenuItem NWSubItem26 = {
   &NWSubItem27,
   73,-8,
#ifdef GERMAN
   131,8,
#else
   99,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHCOMP,
   0,
#ifdef GERMAN
   (APTR)&NWIText39,
#else
   (APTR)&NWIText97,
#endif
   NULL,
   NULL,
   NULL,
   MENUNULL
};

struct IntuiText NWIText98 = {
   WHITE,KMZ,JAM1,
   0,0,
   &TOPAZ80,
   "Type       ",
   NULL
};

struct MenuItem NWMenuItem43 = {
   &NWMenuItem44,
   0,0,
#ifdef GERMAN
   112,8,
#else
   88,8,
#endif
   ITEMTEXT+ITEMENABLED+HIGHBOX,
   0,
#ifdef GERMAN
   (APTR)&NWIText40,
#else
   (APTR)&NWIText98,
#endif
   NULL,
   NULL,
   &NWSubItem26,
   MENUNULL
};

struct Menu NWMenu1 = {
   &NWMenu2,
   0,0,
#ifdef GERMAN
   44,0,
#else
   39,0,
#endif
   MENUENABLED,
#ifdef GERMAN
   "Links",
#else
   "Left",
#endif
   &NWMenuItem43
};

#define NWMenuList1 NWMenu1

struct NewWindow NWNewWindowStructure1 = {
   0,10,
   640,245, //205
   0,1,
#ifndef DEMO20
   MOUSEBUTTONS+GADGETUP+RAWKEY+MENUPICK+MOUSEMOVE|DISKINSERTED|DISKREMOVED,
#else
   INTUITICKS|MOUSEBUTTONS+GADGETUP+RAWKEY+MENUPICK+MOUSEMOVE|DISKINSERTED|DISKREMOVED,
#endif
   ACTIVATE|BORDERLESS|NOCAREREFRESH|REPORTMOUSE|BACKDROP,
   &NWGadget1,
   NULL,
   NULL,
   NULL,
   NULL,
   5,5,
   -1,-1,
   CUSTOMSCREEN
};

UWORD pens[10]={KMZ,KMZ,KMZ,WHITE,GRAY,WHITE,WHITE,BLACK,YELLOW,0xffff};


Prototype struct Screen *FindWorkBench()
{
   struct Screen *s=NULL;
   Forbid();
   if(OpenWorkBench())
      for(s=IntuitionBase->FirstScreen;s && strcmp(s->DefaultTitle,"Workbench Screen");
         s=s->NextScreen);
   Permit();
   return(s);
}

Prototype DetectDimension(ULONG *mode)
{
   if(Kick(36))
   {
      DisplayInfoHandle dih;
      struct DimensionInfo di;

      dih=(void *)FindDisplayInfo(*mode);
      if(GetDisplayInfoData(dih, &di, sizeof(di), DTAG_DIMS, NULL))
      {
         NewScreenStructure.TopEdge=di.TxtOScan.MinX;
         NewScreenStructure.LeftEdge=di.TxtOScan.MinY;
         NewScreenStructure.Width=di.TxtOScan.MaxX-NewScreenStructure.LeftEdge;
         NewScreenStructure.Height=di.TxtOScan.MaxY-NewScreenStructure.TopEdge;
         if((NewScreenStructure.Width<640) || !(*mode & HIRES))
         {
            NewScreenStructure.Width=640;
            NewScreenStructure.LeftEdge=NewScreenStructure.TopEdge=0;
            *mode|=HIRES;
         }
         else if(NewScreenStructure.Width>640)
         {
            int a=NewScreenStructure.Width-640;
            NewScreenStructure.Width=640;
            NewScreenStructure.LeftEdge+=a/2;
         }
      }
   } else
   {
      if(NewScreenStructure.ViewModes&LACE)
         NewScreenStructure.Height=512;
      else
         NewScreenStructure.Height=256;
   }
   NWNewWindowStructure1.Height=NewScreenStructure.Height-11;
}

Prototype OpenScr()
{
   ULONG mode=INVALID_ID;
         
   if(Kick(36))
      if(NTPPREFS.Flags&WBLIKE)
         mode=GetVPModeID(&((struct Screen *)FindWorkBench())->ViewPort);
      
   if (mode==INVALID_ID) mode=mode_id;
         
   DetectDimension(&mode);
   
   if(Kick(36))
      NTPBase->Screen=OpenScreenTags(&NewScreenStructure, SA_Pens, pens, SA_DisplayID, mode, TAG_END);
   else
      NTPBase->Screen=OpenScreen(&NewScreenStructure);
   return(NTPBase->Screen);
}


Prototype struct Window *Open2(struct NewWindow *nw)
{
   if(Kick(39))
      return(OpenWindowTags(nw,WA_NewLookMenus,TRUE,TAG_END));
   else return(OpenWindow(nw));
}

Prototype OpenEnviroment()
{
   char ok=1;
/*   if(IntuitionBase->FirstScreen->Height==200)
      NewScreenStructure.Height=200;
   else if(IntuitionBase->FirstScreen->Height==400)
      NewScreenStructure.Height=200;
   else if(IntuitionBase->FirstScreen->Height==512)
      NewScreenStructure.Height=256;*/

   if(NTPPREFS.Flags&INTERLACE)
   {
      NewScreenStructure.Height*=2;
      NewScreenStructure.ViewModes|=LACE;
   }
   if(NTPPREFS.Flags&INGADGETS) NWNewWindowStructure1.FirstGadget=0;
   NWNewWindowStructure1.Height=NewScreenStructure.Height-11;
   if(OpenScr())
   {
      NWNewWindowStructure1.Screen=NTPBase->Screen;
      if(NTPBase->w=Open2(&NWNewWindowStructure1))
      {
         if(!SetMenuStrip(NTPBase->w,&NWMenu1))
         {
            CloseWindow(NTPBase->w);
            CloseScreen(NTPBase->Screen);
            ok=0;
         } else
         {
            struct Process *proc,*FindTask();
            proc=FindTask(0);
            sw=proc->pr_WindowPtr;
            proc->pr_WindowPtr=(APTR)NTPBase->w;
            if(pbx) SetFont(NTPBase->w->RPort,pbx);
         }
      }
      else
      {
         CloseScreen(NTPBase->Screen);
         ok=0;
      }
   }
   else ok=0;
   return(ok);
}

Prototype CloseEnviroment()
{
   struct Process *proc,*FindTask();
   proc=FindTask(0);
   proc->pr_WindowPtr=sw;
   if(NTPBase->Screen)
   {
      ClearMenuStrip(NTPBase->w);
      CloseWindow(NTPBase->w);
      CloseScreen(NTPBase->Screen);
   }
}

Prototype WriteGadgets(struct FileHandle *f)
{
   Write(f,&(NWGadget2.GadgetText->FrontPen),1);
   Write(f,&(NWGadget3.GadgetText->FrontPen),1);
   Write(f,&(NWGadget4.GadgetText->FrontPen),1);
   Write(f,&(NWGadget5.GadgetText->FrontPen),1);
   Write(f,&(NWGadget6.GadgetText->FrontPen),1);
   Write(f,&(NWGadget8.GadgetText->FrontPen),1);
   Write(f,&(NWGadget9.GadgetText->FrontPen),1);
   Write(f,&(NWGadget10.GadgetText->FrontPen),1);
   Write(f,&(NWGadget11.GadgetText->FrontPen),1);
   Write(f,&(NWGadget12.GadgetText->FrontPen),1);
   Write(f,&(NWGadget14.GadgetText->FrontPen),1);
   Write(f,&(NWGadget15.GadgetText->FrontPen),1);
   Write(f,&(NWGadget16.GadgetText->FrontPen),1);
   Write(f,&(NWGadget17.GadgetText->FrontPen),1);
   Write(f,&(NWGadget18.GadgetText->FrontPen),1);
   Write(f,&(NWGadget1.UserData),4);
   Write(f,&(NWGadget7.UserData),4);
   Write(f,&(NWGadget13.UserData),4);
}

Prototype ReadGadgets(struct FileHandle *f)
{
   Read(f,&(NWGadget2.GadgetText->FrontPen),1);
   Read(f,&(NWGadget3.GadgetText->FrontPen),1);
   Read(f,&(NWGadget4.GadgetText->FrontPen),1);
   Read(f,&(NWGadget5.GadgetText->FrontPen),1);
   Read(f,&(NWGadget6.GadgetText->FrontPen),1);
   Read(f,&(NWGadget8.GadgetText->FrontPen),1);
   Read(f,&(NWGadget9.GadgetText->FrontPen),1);
   Read(f,&(NWGadget10.GadgetText->FrontPen),1);
   Read(f,&(NWGadget11.GadgetText->FrontPen),1);
   Read(f,&(NWGadget12.GadgetText->FrontPen),1);
   Read(f,&(NWGadget14.GadgetText->FrontPen),1);
   Read(f,&(NWGadget15.GadgetText->FrontPen),1);
   Read(f,&(NWGadget16.GadgetText->FrontPen),1);
   Read(f,&(NWGadget17.GadgetText->FrontPen),1);
   Read(f,&(NWGadget18.GadgetText->FrontPen),1);
   Read(f,&(NWGadget1.UserData),4);
   Read(f,&(NWGadget7.UserData),4);
   Read(f,&(NWGadget13.UserData),4);
   NWGadget1.GadgetText->IText=drives[NUMD];
//   if(NTPBase->w) RefreshGList(&NWGadget1,NTPBase->w,0,1);
   NWGadget7.GadgetText->IText=drives[NUMD];
//   if(NTPBase->w) RefreshGList(&NWGadget7,NTPBase->w,0,1);
   NWGadget13.GadgetText->IText=drives[NUMD];
//   if(NTPBase->w) RefreshGList(&NWGadget13,NTPBase->w,0,1);
   NWGadget1.GadgetText->IText=drives[(int)NWGadget1.UserData];
   NWGadget7.GadgetText->IText=drives[(int)NWGadget7.UserData];
   NWGadget13.GadgetText->IText=drives[(int)NWGadget13.UserData];
   if(NTPBase->w) RefreshGadgets(NTPBase->w->FirstGadget,NTPBase->w,0);
}

Prototype DefaultGadgets()
{
   NWGadget2.GadgetText->FrontPen=1;
   NWGadget3.GadgetText->FrontPen=1;
   NWGadget4.GadgetText->FrontPen=1;
   NWGadget5.GadgetText->FrontPen=1;
   NWGadget6.GadgetText->FrontPen=WARN;
   NWGadget8.GadgetText->FrontPen=1;
   NWGadget9.GadgetText->FrontPen=1;
   NWGadget10.GadgetText->FrontPen=WARN;
   NWGadget11.GadgetText->FrontPen=1;
   NWGadget12.GadgetText->FrontPen=1;
   NWGadget14.GadgetText->FrontPen=1;
   NWGadget15.GadgetText->FrontPen=1;
   NWGadget16.GadgetText->FrontPen=1;
   NWGadget17.GadgetText->FrontPen=1;
   NWGadget18.GadgetText->FrontPen=1;
   NWGadget1.UserData=(APTR)5;
   NWGadget7.UserData=(APTR)4;
   NWGadget13.UserData=0;
   NWGadget1.GadgetText->IText=drives[NUMD];
 //  if(NTPBase->w) RefreshGList(&NWGadget1,NTPBase->w,0,1);
   NWGadget7.GadgetText->IText=drives[NUMD];
//   if(NTPBase->w) RefreshGList(&NWGadget7,NTPBase->w,0,1);
   NWGadget13.GadgetText->IText=drives[NUMD];
//   if(NTPBase->w) RefreshGList(&NWGadget13,NTPBase->w,0,1);
   NWGadget1.GadgetText->IText=drives[(int)NWGadget1.UserData];
   NWGadget7.GadgetText->IText=drives[(int)NWGadget7.UserData];
   NWGadget13.GadgetText->IText=drives[(int)NWGadget13.UserData];
   if(NTPBase->w) RefreshGadgets(NTPBase->w->FirstGadget,NTPBase->w,0);
}

Prototype void RefType(char w)
{
   struct MenuItem *ItemAddress();
   int i,m;
   for(i=0;i<7;i++)
   {
      m=SHIFTMENU(w<<2)+SHIFTITEM(0)+SHIFTSUB(i);
      if(i+1==wp[w].Type) ItemAddress(NTPBase->w->MenuStrip,m)->Flags|=CHECKIT|CHECKED;
      else ItemAddress(NTPBase->w->MenuStrip,m)->Flags&=~CHECKIT|CHECKED;
   }
}

Prototype void RefSort(char w)
{
   struct MenuItem *ItemAddress();
   int i,m;
   m=SHIFTMENU(w<<2)+SHIFTITEM(1)+SHIFTSUB(0);
   if(wp[w].Sort==UNSORTED) ItemAddress(NTPBase->w->MenuStrip,m)->Flags|=CHECKIT|CHECKED;
   else ItemAddress(NTPBase->w->MenuStrip,m)->Flags&=~CHECKIT|CHECKED;
   for(i=1;i<4;i++)
   {
      m=SHIFTMENU(w<<2)+SHIFTITEM(1)+SHIFTSUB(i);
      if(i-1==wp[w].Sort) ItemAddress(NTPBase->w->MenuStrip,m)->Flags|=CHECKIT|CHECKED;
      else ItemAddress(NTPBase->w->MenuStrip,m)->Flags&=~CHECKIT|CHECKED;
   }
}

Prototype void RefList(char w)
{
   struct MenuItem *ItemAddress();
   int i,m;
   for(i=0;i<5;i++)
   {
      m=SHIFTMENU(w<<2)+SHIFTITEM(5)+SHIFTSUB(i);
      if(i+1==wp[w].List) ItemAddress(NTPBase->w->MenuStrip,m)->Flags|=CHECKIT|CHECKED;
      else ItemAddress(NTPBase->w->MenuStrip,m)->Flags&=~CHECKIT|CHECKED;
   }
}

Prototype void RefCase(char w)
{
   struct MenuItem *ItemAddress();
   int m;
   m=SHIFTMENU(w<<2)+SHIFTITEM(4);
   if(wp[w].Case) ItemAddress(NTPBase->w->MenuStrip,m)->Flags|=CHECKIT|CHECKED;
   else ItemAddress(NTPBase->w->MenuStrip,m)->Flags&=~CHECKIT|CHECKED;
}

Prototype void RefPrefs()
{
   struct MenuItem *ItemAddress();
   int m;
   m=SHIFTMENU(3)+SHIFTITEM(6);
   if(NTPPREFS.Flags&REQON) ItemAddress(NTPBase->w->MenuStrip,m)->Flags|=CHECKIT|CHECKED;
   else ItemAddress(NTPBase->w->MenuStrip,m)->Flags&=~CHECKIT|CHECKED;
   m=SHIFTMENU(3)+SHIFTITEM(7);
   if(NTPPREFS.Flags&OVWMSG) ItemAddress(NTPBase->w->MenuStrip,m)->Flags|=CHECKIT|CHECKED;
   else ItemAddress(NTPBase->w->MenuStrip,m)->Flags&=~CHECKIT|CHECKED;
   m=SHIFTMENU(3)+SHIFTITEM(5);
   if(!(NTPPREFS.Flags&INGADGETS)) ItemAddress(NTPBase->w->MenuStrip,m)->Flags|=CHECKIT|CHECKED;
   else ItemAddress(NTPBase->w->MenuStrip,m)->Flags&=~CHECKIT|CHECKED;
   m=SHIFTMENU(3)+SHIFTITEM(8);
   if(!(NTPPREFS.Flags&MBLANK)) ItemAddress(NTPBase->w->MenuStrip,m)->Flags|=CHECKIT|CHECKED;
   else ItemAddress(NTPBase->w->MenuStrip,m)->Flags&=~CHECKIT|CHECKED;
   m=SHIFTMENU(3)+SHIFTITEM(9);
   if((NTPPREFS.Flags&COLOR)) ItemAddress(NTPBase->w->MenuStrip,m)->Flags|=CHECKIT|CHECKED;
   else ItemAddress(NTPBase->w->MenuStrip,m)->Flags&=~CHECKIT|CHECKED;
   m=SHIFTMENU(3)+SHIFTITEM(10);
   if((NTPPREFS.Flags&STRICTNC)) ItemAddress(NTPBase->w->MenuStrip,m)->Flags|=CHECKIT|CHECKED;
   else ItemAddress(NTPBase->w->MenuStrip,m)->Flags&=~CHECKIT|CHECKED;
   m=SHIFTMENU(3)+SHIFTITEM(12);
   if(Kick(36))
   {
      if(NTPPREFS.Flags&WBLIKE) ItemAddress(NTPBase->w->MenuStrip,m)->Flags|=CHECKED|CHECKIT;
      else ItemAddress(NTPBase->w->MenuStrip,m)->Flags&=~CHECKIT|CHECKED;
   } else ItemAddress(NTPBase->w->MenuStrip,m)->Flags&=~ITEMENABLED;
}

Prototype void RefOverWrite()
{
   struct MenuItem *ItemAddress();
   int m;
   m=SHIFTMENU(3)+SHIFTITEM(7);

   if(ItemAddress(NTPBase->w->MenuStrip,m)->Flags&(CHECKIT|CHECKED))
      NTPPREFS.Flags|=OVWMSG;
}

struct ModeNode
{
   struct Node n;
   char Name[DISPLAYNAMELEN+1];
   ULONG Mode;
};

struct GadToolsBase *GadToolsBase;

Prototype AskForMode()
{
   enum GO { CANCEL, NOTHING, OK } go=CANCEL;
   struct List list;
   struct ModeNode *mn;
   ULONG did=INVALID_ID;
   struct NameInfo ni;
   struct DimensionInfo di;
   struct Window *w;
   struct Gadget *g, *glist=NULL, *CreateContext();
   struct NewGadget ng;
   DisplayInfoHandle dih;
   APTR vi;
   int i;
   struct IntuiMessage *msg, *GT_GetIMsg();   

   if(!(GadToolsBase=(void *)OpenLibrary("gadtools.library",0))) return(0);   
   NewList(&list);
   while((did=NextDisplayInfo(did))!=INVALID_ID)
   {
      dih=(void *)FindDisplayInfo(did);
      if(GetDisplayInfoData(dih, &ni, sizeof(ni), DTAG_NAME, NULL))
      {
         if(GetDisplayInfoData(dih, &di, sizeof(di), DTAG_DIMS, NULL))
            if((di.TxtOScan.MaxX-di.TxtOScan.MinX>=500) && (did & HIRES))
            {
               if(mn=(void *)malloc(sizeof(struct ModeNode)))
               {
                  strcpy(mn->Name, ni.Name);
                  mn->Mode=did;
                  mn->n.ln_Name=mn->Name;
                  mn->n.ln_Pri=0;
                  mn->n.ln_Type=NT_GRAPHICS;
                  AddTail(&list, mn);
                  go=NOTHING;
               }
            }
      }
   }
   w=(void *)OpenWindowTags(NULL,
                    WA_Left, 10,
                    WA_Top, 50,
                    WA_Width, 300,
                    WA_Height, 140,
                    WA_Flags, SMART_REFRESH|WINDOWCLOSE| ACTIVATE | WINDOWDRAG | WINDOWDEPTH,
                    WA_IDCMP, LISTVIEWIDCMP|CLOSEWINDOW,
                    WA_CustomScreen, NTPBase->Screen,
                    WA_Title, E("Select mode"),
                    TAG_DONE, NULL);
   if(w)
   {
      vi=(void *)GetVisualInfoA(NTPBase->Screen,NULL);
      g=CreateContext(&glist);
      ng.ng_LeftEdge=4; ng.ng_TopEdge=NTPBase->Screen->BarHeight+1;
      ng.ng_Width=292; ng.ng_Height=142-ng.ng_TopEdge;
      ng.ng_GadgetText=NULL;
      ng.ng_TextAttr=&TOPAZ60;
      ng.ng_GadgetID=1;
      ng.ng_Flags=NULL;
      ng.ng_VisualInfo=vi;
   
      CreateGadget(LISTVIEW_KIND, g, &ng, GTLV_Labels, &list, TAG_DONE);
      AddGList(w, glist, 0,-1,NULL);
      RefreshGList(glist, w, NULL, -1);
      GT_RefreshWindow(w, NULL);
      
      while(go==NOTHING)
      {
         WaitPort(w->UserPort);
         while(msg=GT_GetIMsg(w->UserPort))
         {
            switch(msg->Class)
            {
               case CLOSEWINDOW: go=CANCEL;
                                 break;
               case GADGETUP: i=msg->Code;
                              go=OK;
                              break;
            }
            GT_ReplyIMsg(msg);
         }
      }
      
      CloseWindow(w);
   }
   
   FreeGadgets(glist);
   FreeVisualInfo(vi);
   
   if(go==OK)
   {
      mn=(struct ModeNode *)list.lh_Head;
      while(i--) mn=(void *)mn->n.ln_Succ;
      mode_id=mn->Mode;
   }

   while(mn=(void *)RemTail(&list))
      free(mn);
   CloseLibrary(GadToolsBase);
   return(go==OK);
}
